/*
   Copyright (c) 2015 Mingsong Chen, Lei Zhou and Geguang Pu
   East China Normal University. RCS tool set version 1.0
*/
#include <stdio.h>

#include <sys/time.h>
#include <sys/resource.h>
#include <unistd.h>

#include "Graph.h"
#include "HLS.h"
#include "FuncTimer.h"
#include <omp.h>
#include <map>
#include <set>
#include <iostream>
#include <fstream>
#include <time.h>
#include <string>
#include <stdlib.h>
#include <stdio.h>
#include "Graph.h"
#include "FuncTimer.h"
#include "Config.h"
#include <vector>
#include <algorithm>
#include <list>
#include <limits.h>
//#include <windows.h>
//#include <direct.h>
//#include <process.h>
//#include "stdafx.h"

using namespace std;
using namespace __gnu_cxx;
#define CORES 1

//#define INT_MAX 0x7fffffff
// optimization:
// ASAP
// ALAP
// pruning
fstream fout;
int latex_global;
int latex_optimal;
float latex_not_c;
float latex_not_t;
float latex_level_c;
float latex_level_t;
float latex_termi_c;
float latex_termi_t;
float latex_shrin_c;
float latex_shrin_t;
float latex_1p_c;
float latex_1p_t;
float latex_2p_c;
float latex_2p_t;
float latex_to_c;
float latex_to_t;


		bool config_echo ;
		bool config_level ;
		bool config_low ;

bool needreturn = false;
int return_id = -1;


static bool
operator < ( Operation const &op1, Operation const &op2 )
{
    return ( op1.sort_id >= op2.sort_id );
}


void

printInfo( char *str )
{

    printf( str );

    printf( "\n" );

    fout << str << "\n";

    fout.flush();
}


double GetTickCount(void) 
{
 struct rusage ru;
    getrusage(RUSAGE_THREAD, &ru);
    return (double)ru.ru_utime.tv_sec + (double)ru.ru_utime.tv_usec / 1000000; 
}

class thread_ag
{

public:

    int lower;
    int upper;
    int coreID;
    int * assignmentSemaphore;//
    set < int > * assignmentMap;
};

class search_ag
{
public:
    int step;
    int op;
    int core;
    bool updateALAP;
    bool cpbound;
    bool levelbound;
    bool lowbound;
    bool preSearch;

 //   int * assignmentSemaphore; //

 //   set < int > * assignmentMap;
};


class scheduler;

class cooperation
{ 
	public:
 		omp_lock_t lock;


		int scheduleNum;
		scheduler * schedules;

                int winner;
                int winnerScheduleTime;

		void get_winner (int & i, int & t)
		;

		void set_winner(int i, int t)
		;


		cooperation(int n)
		;

		~cooperation()
		;

	void setScheduleNum(int n);

};








class scheduler
{
	public:

    double start ;
    double end ;

                bool change;
		int optimalScheduleTime ;
		int listSchedulingTime ;
		int basicSchedulingTime ;
		int w ;
		int level_count ;
		int schedule_ID ;
		int total_schedules;
                cooperation *  coop;

		map < int, map < Operation *, int > >currentSchedule_p;
		map < int, map < Operation *, int > >optimalSchedule_p;
		map < int, map < type, map < int, int > > > resources_p;
		map < int, map < type, map < int, int > > > resource_snapshot_p;

			vector < map < int, map < type, map < int, int > > >   >   resource_history;
                        vector < map < int, map < Operation *, int > > > schedule_history;



		// resource usage. Records resource usage.
		map < type, map < int, int > >resources;

		// resource pool.
		// Initialized when constructing from test case file.
		 map < type, int >resourcePool;
  map < type, int >resourcePower;


		// operation pool.
		// Initialized when constructing from test case file.
		map < int, Operation * >operations;


		// constraint pool.
		// Initialized when constructing from test case file.
		set < Dependency * >dependencies;

		// container for current schedule
		// Constructed on the fly.
		map < Operation *, int >currentSchedule;


		// container for best schedule sofar
		// Constructed on the fly.
		map < Operation *, int >optimalSchedule;
		map < Operation *, int >listingSchedule;
		map < Operation *, int >basicSchedule;
		map < Operation *, int >lastFeasibleSchedule;


		map < Operation *, int >CPofSubGraph;
		map < Operation *, int >CPofSubGraph_;
		map < Operation *, int >CPofPredGraph;
		map < Operation *, int >CPofPredGraph_;
		map < Operation *, int >CPofPreRevGraph;
		map < Operation *, int >CPofPreRevGraph_;

		map < Operation *, map < Operation *, int > >CPofNodes;
		map < int, map < Operation *, int > >ASAPofMultiThread;
		map < int, map < Operation *, int > >ALAPofMultiThread;

		map < Operation *, set < Operation * > >immediatePrecedentOperations;
		map < Operation *, set < Operation * > >successorOperations;
		map < int, set < int > >level_l_h;

		map <int, map<Operation *, bool> > precedenceRecord;
		map<int, int> levelbound_info;
		map<int, int> endofLevel; // end of cut now
	//	map<int, int> levelcut;
            

		// container for source operations
		// not used
		set < Operation * >sourceOperations;
		multiset < Operation  > topoSet;

		// container for sink operations
		// not used
		multiset < Operation* > sinkOperations;

		multiset < Operation > sortedSetByALAP;
		multiset < Operation > sortedSetByCP;


		int maxOpTraversed ;

		int globalLow  ;

		bool terminateBB ;
		bool basicfound ;

		bool completeBranchBound ;
		int total_traverse ;
		int total_duration ;

		thread_ag  threadInfo;
		search_ag  searchInfo;

		///////////////////////////////
		scheduler()
		{

		start =0; end=0;
		change =false;
				 optimalScheduleTime = INT_MAX;
		 listSchedulingTime = 0;
		 basicSchedulingTime = INT_MAX;
		 w = INT_MAX;
		 level_count = 0;
		 schedule_ID =-1;

//	 config_echo = false;
//		 config_level = false;
//		 config_low = false;

		 maxOpTraversed = 0;

		 globalLow = 0;

		 terminateBB = false;
		 basicfound = false;

		 completeBranchBound = false;
		 total_traverse = 0;
		 total_duration = 0;


		}
               
                void set_cooperation(cooperation * cop)
		{
			coop=cop;
		}
	


	void addOperation(int id, int tp, int level, int graph, int add_delay, int multi_delay, int div_delay, int mem_delay, int shift_delay, int other_delay)
	{
			Operation * op = new Operation();

			op->base_addr = op;

			op->id = id;

			op->visited = false;

			op->CPofPreRevGraph = -1;

			op->CPPredGraph = -1;

			op->CPSubGraph = -1;

			op->level = level;

			op->graph = graph;

			op->graph_count = max( op->graph_count, graph );


			if( tp == add )

			{

				op->t = add;

				op->delay = add_delay;

			}

			else if( tp == multiplication )

			{

				op->t = multiplication;

				op->delay = multi_delay;

			}

else if( tp == divide )

			{

				op->t = divide;

				op->delay = div_delay;

			}
else if( tp == memory )

			{

				op->t = memory;

				op->delay = mem_delay;

			}
else if( tp == shift )

			{

				op->t = shift;

				op->delay = shift_delay;

			}
else if( tp == other )

			{

				op->t = other;

				op->delay = other_delay;

			}

			operations[id] = op;	


		}

		void 	addDependences(int i, int source, int sink)
		{

			Dependency * dep = new Dependency();


			dep->id = i;

			dep->sink = operations[sink];

			dep->source = operations[source];


			dependencies.insert( dep );

			operations[source]->adj.insert( dep );

			operations[sink]->in.insert( dep );

		}




		void topoSort()
		{

			set< int > tempOp;
			level_l_h.clear();
			level_count = 0;


			for( map<int, Operation *>::const_iterator it = operations.begin(); it != operations.end(); it++ )
			{
				tempOp.insert( ( *it ).second->id );
			}

			int levelCount = 1;

			while( tempOp.size() != 0 )
			{
				set< int > tempOpSet;

				for( set < int >::const_iterator it =
						tempOp.begin(); it != tempOp.end(); it++ )

				{

					Operation * op = operations[ *it ];
					bool noIn = true;

					for( set < Dependency* >::const_iterator it2 = op->in.begin(); it2 != op->in.end(); it2++ )
					{
						Dependency * dep = *( it2 );

						if( tempOp.find( dep->source->id ) != tempOp.end() )
							noIn = false;
					}

					if( noIn )
						tempOpSet.insert( *it );
				}



				for( set<int>::const_iterator it = tempOpSet.begin(); it != tempOpSet.end(); it++ )
				{
					operations[*it]->level = levelCount;
					operations[*it]->sort_id = -levelCount;

					tempOp.erase( *it );
				}

				levelCount++;

				level_count = max( level_count, levelCount );

			}

			///////////added by mingsong
			//  for(int l=1; l<=levelCount; l++)
			//  {
			//   history_level_info[l] = new vector<int>();
			//}

			for( set < Dependency * >::const_iterator edge_it = dependencies.begin(); edge_it != dependencies.end(); edge_it++ )
			{
				int src = (*edge_it)->source->id;
				int dest = (*edge_it)->sink->id;
                               				int src_level = operations[src]->level;
				int dest_level = operations[dest]->level;

			for(int l=src_level; l<dest_level; l++) 
				{	level_l_h[src_level].insert( src );
				}
				level_l_h[dest_level].insert(dest);
			}
			///////////////////////


			level_count--;

			for( map<int, Operation*>::const_iterator it = operations.begin(); it != operations.end(); it++ )
			{
				topoSet.insert( *( *it ).second );
			}
		}

		void  initASAP()
			{

				for( map < int, Operation * >::const_iterator it =
						operations.begin(); it != operations.end(); it++ )

				{

					Operation * op = ( *it ).second;

					op->ASAP = CPofPredGraph[op] + 1;
				}
			}



		// initialize data structures of the given DFG
		void initDFG()
			{

				// get all sink operations and source operations of the DFG
				for( map < int, Operation * >::const_iterator it =
						operations.begin(); it != operations.end(); it++ )

				{

					Operation * op = ( *it ).second;

					sinkOperations.insert( op );

					sourceOperations.insert( op );

				}

				for( set < Dependency * >::const_iterator it =
						dependencies.begin(); it != dependencies.end(); it++ )

				{

					Dependency * dep = ( *it );

					sinkOperations.erase( dep->source );

					sourceOperations.erase( dep->sink );

				}


				// calculate level
				// printf( "Calculating level for ops...\n" );

				// for( set<Operation*>::const_iterator it =
				// sourceOperations.begin(); it != sourceOperations.end(); it++ )
				// {
				// Operation * op = ( *it );
				// DFS( op, 0 );
				// }

				// longest path algorithm
				floydWarshall();

				printf( "Initializing CP...\n" );

				CPofSubGraph.clear();
				CPofPredGraph.clear();
				CPofPreRevGraph.clear();
				CPofPredGraph_.clear();

				for( multiset<Operation>::const_iterator it = topoSet.begin(); it != topoSet.end(); it++ )

				{

					//       printf ("Processing op %d of %d\n", i, operations.size ());

					Operation * op = operations[it->id];

					CPofSubGraph[op] =
						getCriticalPathLength( getSubGraph( op ), cpofsub );

					CPofPredGraph[op] =
						getCriticalPathLength( getPrecedenceGraph( op ), cpofpred );

					CPofPredGraph_[op] = getCriticalPathLength( getPrecedenceGraph( op ), cpofpred_ );

					CPofPreRevGraph[op] =
						getCriticalPathLength( getPrecedenceGraph
								( op,
								  getReversedGraph( getSubGraph( op ) ) ),
								cpofpredresv );

					//    level_l_h[CPofPredGraph_[op]].insert( op->id );
					//    level_count = max( level_count, CPofPredGraph_[op] );

				}






				printf( "Initializing Immediate Precedent...\n" );


				for( int i = 1; i <= operations.size(); i++ )

				{

					Operation * op = operations[i];

					immediatePrecedentOperations[op] = getImmediatePrecedent( op );

				}

				printf( "Initializing Successors...\n" );


				for( int i = 1; i <= operations.size(); i++ )

				{

					Operation * op = operations[i];

					successorOperations[op] = getSuccessor( op );

				}




				printf( "Initializing ASAP...\n" );

				initASAP();
			}

		void
			preEnumaration()
			{
				resources.clear();
				//	basicEnu( 1 );
				//	resources.clear();
				listSchedule();




				// getBadSchedule();
				printf( "Initializing ALAP...\n" );

				initALAP();
				

				sortedSetByALAP.clear();

				for( int i = 1; i <= operations.size(); i++ )

				{
					//		operations[i]->sort_id = -operations[i]->ASAP ;
					operations[i]->sort_id = -operations[i]->ALAP;
					sortedSetByALAP.insert( *operations[i] );
					
				}



				writeSchedule( "ALAP" );


				if( true )
				{
					int count = 1;

					for( multiset < Operation >::iterator it = sortedSetByALAP.begin();
							it != sortedSetByALAP.end(); it++ )
					{

						operations[count]->sortedOp = operations[( *it ).id];

						count++;
                                                if(endofLevel[( *it ).level]==NULL)
						       operations[(*it).id] -> pre_id = -1;
						else
							operations[(*it).id] -> pre_id = endofLevel[(*it).level]; 	
						endofLevel[( *it ).level] = ( *it ).id;
					}
 
                                 	for( multiset < Operation >::iterator it = sortedSetByALAP.begin();
							it != sortedSetByALAP.end(); it++ )
					{
                                                if( operations[(*it).id] -> pre_id == -1)
						{
							if(( *it ).level==1) continue;
							else
							operations[(*it).id] -> pre_id  = endofLevel[(*it).level-1]; 	
						}

					}

					
				}


				fout << "++++++++++++++++++++++++++\n";

			//	fout << "current adder: " << add_count << "\n";

			//	fout << "current muliplier: " << multi_count << "\n";




				printf( "Estimated space: %d\n", getEstimatedSpace() );

				fout << "Estimated space: " << getEstimatedSpace() << " \n";


				fout << "\nList scheduling\n";

				fout << "The list schedule time is " << listSchedulingTime << "\n";


				for( int i = 1; i <= operations.size(); i++ )
				{
					Operation * op = operations[i];
					fout << op->id << "\t" << listingSchedule[op] << " " << op->
						ASAP << " " << op->ALAP << "\n";

				}

				fout.flush();


				resetContext();

/*for(int i=1; i<=level_l_h.size(); i++){
                           levelcut[i] = *  level_l_h[i].begin();
set < int >::iterator iit;  
			    for(iit= level_l_h[i].begin(); iit != level_l_h[i].end() ; iit++)
                                   if(levelcut[i]<*iit) levelcut[i] = *iit;
		    }
*/

			}




		inline unsigned long long
			GetCycleCount()
			{
				//__asm _emit 0x0F
				//__asm _emit 0x31
				return 0;
			}



		void

			floydWarshall()
			{

				// init
				CPofNodes.clear();


				for( set < Dependency * >::const_iterator it =
						dependencies.begin(); it != dependencies.end(); it++ )

				{

					CPofNodes[( *it )->source][( *it )->sink] = ( *it )->source->delay;

				}


				for( int k = 1; k <= operations.size(); k++ )

				{

					for( int i = 1; i <= operations.size(); i++ )

					{

						for( int j = 1; j <= operations.size(); j++ )

						{

							// int test1 =
							// CPofNodes[operations[i]][operations[j]];
							// int test2 =
							// CPofNodes[operations[i]][operations[k]];
							// int test3 =
							// CPofNodes[operations[k]][operations[j]];
							if( CPofNodes[operations[i]][operations[k]] != 0
									&& CPofNodes[operations[k]][operations[j]] != 0 )

								CPofNodes[operations[i]][operations[j]] =
									max( CPofNodes[operations[i]][operations[j]],
											CPofNodes[operations[i]][operations[k]] +
											CPofNodes[operations[k]][operations[j]] );

						}

					}

				}
			}




		// for procedure "getSubGraph" find the sink ops of a specified op
		void
			addSink( Operation * op, Graph * graph )
			{

				if( op->adj.size() == 0 )

					return;


				for( set < Dependency * >::const_iterator it = op->adj.begin();
						it != op->adj.end(); it++ )

				{

					Dependency * dep = ( *it );


					graph->dependencies.insert( dep );

					graph->operations.insert( dep->sink );

					addSink( dep->sink, graph );

				}
			}


		// for procedure "getPrecedenceGraph" find the source op of a
		// specified op
		void
			addSource( Operation * op, Graph * graph, Graph * base )
			{

				for( set < Dependency * >::const_iterator it =
						base->dependencies.begin(); it != base->dependencies.end();
						it++ )

				{

					Dependency * dep = ( *it );


					if( dep->sink == op )

					{

						graph->dependencies.insert( dep );

						graph->operations.insert( dep->source );

						addSource( dep->source, graph, base );

					}

				}

			}


		// for procedure "getPrecedenceGraph" find the source op of a
		// specified op
		void
			addSource( Operation * op, Graph * graph )
			{

				for( set < Dependency * >::const_iterator it = dependencies.begin();
						it != dependencies.end(); it++ )

				{

					Dependency * dep = ( *it );


					if( dep->sink == op )

					{

						graph->dependencies.insert( dep );

						graph->operations.insert( dep->source );

						addSource( dep->source, graph );

					}

				}
			}


		// get sub graph
		Graph * getSubGraph( Operation * op )
		{

			Graph * rs = new Graph();

			const Operation *curOp = op;



			rs->operations.insert( op );

			// get source recursively
			addSink( op, rs );


			rs->initGraph();


			return rs;
		}


		// get precedence graph
		Graph * getPrecedenceGraph( Operation * op, Graph * base )
		{

			Graph * rs = new Graph();

			const Operation *curOp = op;



			rs->operations.insert( op );

			// get source recursively
			addSource( op, rs, base );


			rs->initGraph();

			return rs;
		}


		// get precedence graph
		Graph * getPrecedenceGraph( Operation * op )
		{

			Graph * rs = new Graph();

			const Operation *curOp = op;



			rs->operations.insert( op );

			// get source recursively
			addSource( op, rs );


			rs->initGraph();

			return rs;
		}


		// get reversed graph
		Graph * getReversedGraph( Graph * graph )
		{

			Graph * rs = new Graph();

			rs->operations = graph->operations;


			for( set < Dependency * >::const_iterator it =
					graph->dependencies.begin(); it != graph->dependencies.end();
					it++ )

			{

				Dependency * dep1 = ( *it );

				Dependency * dep2 = new Dependency( dep1->sink, dep1->source );


				rs->dependencies.insert( dep2 );

			}


			rs->initGraph();


			return rs;
		}



		int
			getCriticalPathLength( Graph * g, enum cptype type )
			{

				if( type == cpofsub )

				{

					set < int >rs;



					for( set < Operation * >::const_iterator it =
							g->sourceOps.begin(); it != g->sourceOps.end(); it++ )

					{

						int depth = 0;


						Operation * op = ( *it );

						rs.insert( DFS( g, &rs, op, depth, type, false ) );

					}

					int len = *rs.rbegin();



					return len;

				}

				else if( type == cpofsub_ )

				{

					set < int >rs;



					for( set < Operation * >::const_iterator it =
							g->sourceOps.begin(); it != g->sourceOps.end(); it++ )

					{

						int depth = 0;


						Operation * op = ( *it );

						rs.insert( DFS( g, &rs, op, depth, type, true ) );

					}

					int len = *rs.rbegin();



					return len;

				}

				else if( type == cpofpred )

				{


					if( g->operations.size() == 1 )

					{

						Operation * op = *g->operations.begin();

						return 0;

					}

					else

					{
						int rs = 0;
						Operation * sink = operations[( *g->sinkOp.begin() )->id];

						for( set<Operation*>::const_iterator it = g->sourceOps.begin(); it != g->sourceOps.end(); it++ )
							rs = max( rs, CPofNodes[operations[( *it )->id]][operations[( *g->sinkOp.begin() )->id]] );



						return rs;

					}


				}

				else if( type == cpofpred_ )
				{

					if( g->operations.size() == 1 )

					{

						//Operation * op = *g->operations.begin();

						return 1;

					}

					else

					{

						Operation * source = *g->sourceOps.begin();

						Operation * sink = *g->sinkOp.begin();

						return source->CPSubGraph - sink->CPSubGraph;

					}

				}

				else if( type == cpofpredresv )

				{


					if( g->operations.size() == 1 )

					{

						Operation * op = *g->operations.begin();

						return op->delay;

					}

					else

					{

						Operation * source = *g->sourceOps.begin();

						Operation * sink = *g->sinkOp.begin();

						return sink->CPSubGraph - source->CPSubGraph + source->delay;

					}


				}

			}


		unsigned long long
			getEstimatedSpace()
			{

				unsigned long long rs = 1;



				for( int i = 1; i <= operations.size(); i++ )

					rs *= ( operations[i]->ALAP - operations[i]->ASAP );


				return rs;
			}


		// DFS for CP calculation
		int
			DFS( Graph * g, set < int >*rs, Operation * op, int depth,
					enum cptype type, bool isSimple )
			{

				// printf( "DFS: processing op %d...\n", op->id );
				int *targetcp;



				switch( type )

				{

					case cpofsub:

						targetcp = &op->CPSubGraph;

						break;

					case cpofpred:

						targetcp = &op->CPPredGraph;

						break;

					case cpofpredresv:

						targetcp = &op->CPofPreRevGraph;

						break;

				}


				if( *targetcp != -1 && type == cpofsub )

					return *targetcp;


				bool hit = false;


				for( set < Dependency * >::const_iterator it =
						g->dependencies.begin(); it != g->dependencies.end(); it++ )

				{

					Dependency * dep = ( *it );


					if( dep->source == op )

					{

						*targetcp =
							max( op->delay + DFS( g, rs, dep->sink, depth, type, isSimple ),
									*targetcp );

						hit = true;

					}

				}


				if( !hit )

				{

					*targetcp = isSimple ? 1 : op->delay;

				}


				return *targetcp;
			}




		// DFS for level calculation
		void
			DFS( Operation * op, int depth )
			{

				// printf( "DFS Level: processing op %d...\n", op->id );
				if( op->visited )

					return;


				depth++;

				op->level = depth;

				level_l_h[depth].insert( op->id );


				if( op->adj.size() == 0 )

					return;


				for( set < Dependency * >::const_iterator it = op->adj.begin();
						it != op->adj.end(); it++ )

				{

					Dependency * dep = ( *it );

					// calculate level on the fly

					DFS( dep->sink, depth );

				}


				op->visited = true;
			}


	
		void

			initALAP()
			{

				for( map < int, Operation * >::const_iterator it =
						operations.begin(); it != operations.end(); it++ )

				{

					Operation * op = ( *it ).second;

					op->ALAP = w - CPofPreRevGraph[op] + 1;
				}
			}

		void

			printCurrentSchedule( int i )
			{

				// fout << "current schedule:
				for( int j = 1; j <= i; j++ )

				{

					printf( "%d %%%.0f ", currentSchedule[operations[j]],
							( currentSchedule[operations[j]] - operations[j]->ASAP +
							  1.0 ) / ( operations[j]->ALAP - operations[j]->ASAP +
								  1.0 ) * 100 );

					// fout << currentSchedule[operations[j]];

				}

				// fout <<"\n";
				printf( "\n" );
			}

		void

			printCurrentSchedule( int core, int i )
			{

				// fout << "current schedule:
				printf( "thread %d: ", core );


				for( int j = 1; j <= i; j++ )

				{

					printf( "%d %%%.0f ", currentSchedule_p[core][operations[j]],
							( currentSchedule_p[core][operations[j]] -
							  operations[j]->ASAP + 1.0 ) / ( operations[j]->ALAP -
								  operations[j]->ASAP +
								  1.0 ) * 100 );

					// fout << currentSchedule[operations[j]];

				}

				// fout <<"\n";
				printf( "\n" );
			}

		void
			writeSchedule( char *info )
			{

				fout << info << " found a schedule:\n";


				for( int j = 1; j <= operations.size(); j++ )

				{

					fout << currentSchedule[operations[j]] << "\t" <<
						operations[j]->ASAP << "\t" << operations[j]->ALAP << "\n";

				}

				fout << "\n";

				fout.flush();
			}

		void

			writeSchedule( int core )
			{

				fout << "found a schedule at thread " << core << " ";


				for( int j = 1; j <= operations.size(); j++ )

				{

					fout << currentSchedule_p[core][operations[j]] << " ";

				}

				fout << "\n";

				fout.flush();
			}


		void

			saveASAP()
			{

				for( int i = 1; i <= operations.size(); i++ )

				{

					// tempASAP[operations[i]] = operations[i]->ASAP;
				}
			}

		void

			restoreASAP()
			{

				for( int i = 1; i <= operations.size(); i++ )

				{

					// operations[i]->ASAP = tempASAP[operations[i]];
				}
			}

		bool CPBound( Operation * op )
		{

			bool rs = true;

		//	FuncTimer::checkin( cpbound_t );


			int l = *level_l_h[op->level].begin();

			int h = *level_l_h[op->level].rbegin();



			for( int i = l; i <= h; i++ )

			{

				Operation * opi = operations[i];


				rs =
					rs & ( currentSchedule[op] + CPofSubGraph[op] >=
							optimalSchedule[opi] + CPofSubGraph[opi] );


			}

		//	FuncTimer::checkout( cpbound_t );

			return rs;
		}


	/*	bool CPBound( int core, Operation * op )
		{

			bool rs = true;


			int l = *level_l_h[op->level].begin();

			int h = *level_l_h[op->level].rbegin();



			for( int i = l; i <= h; i++ )

			{

				Operation * opi = operations[i];

				rs =
					rs & ( currentSchedule_p[core][op] + CPofSubGraph[op] >=
							optimalSchedule_p[core][opi] + CPofSubGraph[opi] );

			}

			return rs;
		}*/


		void
			branchBoundRCS_h( int i )

			{

				if( i == operations.size() + 1 )

				{

					if( optimalScheduleTime > calculateMaxScheduleTime() )

					{

						optimalSchedule = currentSchedule;

						optimalScheduleTime = calculateMaxScheduleTime();

					}

				}

				else

				{

					Operation * op = operations[i];


					for( int step = op->ASAP; step <= op->ALAP; step++ )

					{

						map < Operation *, int >tempASAP;



						// save ASAP
						for( int i = 1; i <= operations.size(); i++ )

							tempASAP[operations[i]] = operations[i]->ASAP;


						if( isResourceAvailable( step, op->t, op->delay ) )

						{

							int l = lowBound( op );

							int u = upperBound( op );



							if( u < optimalScheduleTime )

							{


							}

						}

					}

				}


			}


		// main HLS algorithm +
		void
			branchBoundRCS( int i, bool update, bool bCPbound, bool blevelBound )
			{

				total_traverse++;

				maxOpTraversed = max( maxOpTraversed, i );

				// printf( "branchBoundRCS: processing op %d...\n", i );

				if( i <= operations.size() )

				{

					Operation * op = operations[i];


					for( int step = op->ASAP; step <= op->ALAP; step++ )

					{

						map < Operation *, int >tempASAP;



						// save ASAP
						for( int i = 1; i <= operations.size(); i++ )

							tempASAP[operations[i]] = operations[i]->ASAP;


						// pass step as step into isPrecedence &
						// isResourceAvailable
						if(	// isPrecedence( op, step ) &&
								isResourceAvailable( step, op->t, op->delay ) )

						{

							currentSchedule[op] = step;


							if( i <= 4 )

								printCurrentSchedule( i );


							// //todo: justify
							if( bCPbound && CPBound( op ) )

								return;


							if( blevelBound && levelBound( op ) )

								return;



							// if( bTOPObound && topoBound( op ) )
							// continue;

							if(	// !blowbound ||
									lowBound( op ) < optimalScheduleTime )

							{

								occupyResource( step, op->t, op->delay );

								updateASAP( op, step );


								if( update )

								{

									updateALAP( op );

								}



								branchBoundRCS( i + 1, update, bCPbound,
										blevelBound );

								releaseResource( step, op->t, op->delay );

							}

							else

							{

								// printf( "*" );
								// fout << "omit from lowbound at op " << op->id
								// << " at level " << op->level << "\n";
								// printf( "return from low bound at " );
								// printCurrentSchedule( i );
								continue;

							}

						}


						for( int i = 1; i <= operations.size(); i++ )

							operations[i]->ASAP = tempASAP[operations[i]];

					}
				}

				else

				{

					completeBranchBound = true;


					int scheduleTime = calculateMaxScheduleTime();


					printf( "bb: found a schedule: %d ", scheduleTime );

					lastFeasibleSchedule = currentSchedule;


					for( int i = 1; i <= operations.size(); i++ )

						printf( "%d", currentSchedule[operations[i]] );


					printf( "\n" );

					fout << "bb: found a shcedule\n";

					writeSchedule( "Found by BB" );

					fout.flush();

					if( optimalScheduleTime >= scheduleTime )

					{

						completeBranchBound = true;

						optimalScheduleTime = scheduleTime;

						optimalSchedule = currentSchedule;


						// update alap
						// printf( "found update!\n" );

						// for( int k = 1; k <= operations.size(); k++ )
						// {
						// Operation * opk = operations[k];
						// opk->ALAP = min( opk->ALAP, optimalScheduleTime -
						// CPofPreRevGraph[opk] + 1 );
						// }
					}

				}
			}


		void
			coreScheduler( void *arg )
			{

				thread_ag * ta = ( thread_ag * ) arg;

				int current = ta->lower;


				int coreThread;//


				while( current <= ta->upper )

				{

					search_ag * sa = ( search_ag * ) malloc( sizeof( search_ag ) );

					sa->core = ta->coreID;

					sa->op = 1;

					sa->step = current;

					sa->updateALAP = true;

					sa->cpbound = true;

					// WaitForSingleObject( *ta->assignmentSemaphore, 0L );


					if( ta->assignmentMap->find( current ) == ta->assignmentMap->end() )

					{

						current++;

						free( sa );

						//  ReleaseSemaphore( *ta->assignmentSemaphore, 1, NULL );
						//sem_post( ta->assignmentSemaphore );

						continue;

					}


					ta->assignmentMap->erase( current );

					//ReleaseSemaphore( *ta->assignmentSemaphore, 1, NULL );
					//sem_post( ta->assignmentSemaphore );

					//coreThread = ( int )_beginthread( branchBoundRCS_thread, 0, ( void* )sa );//

					//SetThreadAffinityMask (coreThread, (DWORD_PTR) ta->coreID);

					// SetThreadPriority( coreThread, THREAD_PRIORITY_HIGHEST );
					//WaitForSingleObject( coreThread, INFINITE );
					//        pthread_join( coreThread, NULL );

					free( sa );


					current++;

				}

				//WaitForSingleObject( *ta->assignmentSemaphore, 0L );
				//    sem_wait( ta->assignmentSemaphore );

				int remain = ta->assignmentMap->size();



				while( remain != 0 )

				{

					search_ag * sa = ( search_ag * ) malloc( sizeof( search_ag ) );

					sa->core = ta->coreID;

					sa->op = 1;

					sa->step = *ta->assignmentMap->begin();

					ta->assignmentMap->erase( sa->step );

					//ReleaseSemaphore( *ta->assignmentSemaphore, 1, NULL );
					//sem_post( ta->assignmentSemaphore );

					// coreThread = ( int )_beginthread( branchBoundRCS_thread, 0, ( void* )sa );//
					//pthread_create( &coreThread, NULL, branchBoundRCS_thread,
					//                ( void * ) sa );

					//SetThreadAffinityMask (coreThread, (DWORD_PTR) ta->coreID);

					// SetThreadPriority( coreThread, THREAD_PRIORITY_HIGHEST );
					//WaitForSingleObject( coreThread, INFINITE );
					//       pthread_join( coreThread, NULL );

					free( sa );

					//WaitForSingleObject( *ta->assignmentSemaphore, 0L );
					//        sem_wait( ta->assignmentSemaphore );

					remain = ta->assignmentMap->size();

				}

				//ReleaseSemaphore( *ta->assignmentSemaphore, 1, NULL );
				//    sem_post( ta->assignmentSemaphore );

			}





void testDriver( char *info, bool shrink, bool lowbound, bool level, bool twophase )
{
    fout << "\nshrink: " << shrink << " termination: " << lowbound << " level: " << level << " two-phase: " << twophase << "\n";
    resetContext();
    printInfo( "\n" );
    printInfo( info );
    search_ag * sa = ( search_ag * ) malloc( sizeof( search_ag ) );
    sa->core = 1;
    sa->op = 1;
    sa->step = -1;
    sa->updateALAP = shrink;
    sa->preSearch = twophase;
    sa->levelbound = level;
    sa->lowbound = lowbound;
    printInfo( "pre-search...\n" );
    latex_global = globalLow = lowBound( 1, NULL );

    updateALAP( 1, NULL, shrink );

    fout << "\nglobal low: " << globalLow << "\n";

  start = GetTickCount();

    if( twophase )
    {
              currentSchedule_p[1].clear();
        branchBoundRCS_thread( sa );
        end = GetTickCount();
        fout << "pre-search total duration: " << end - start << "\n";

        latex_1p_c = total_traverse;
        latex_1p_t = end - start;
    }

    fout << "pre traverse: " << total_traverse << "\n";
    total_traverse = 0;
    sa->preSearch = false;
    printInfo( "formal-search...\n" );
  //  start = GetTickCount();
    currentSchedule_p[1].clear();
    branchBoundRCS_thread( sa );
    end = GetTickCount();

    printInfo( info );

    latex_optimal = optimalScheduleTime;



    for( int i = 1; i <= operations.size(); i++ )
    {
        Operation * op = operations[i];
        fout << op->id << "\t" << optimalSchedule_p[1][op] << "\n";
    }

    fout << "Finished branchbound? " << completeBranchBound << "\n";
    total_duration = end - start;
   
   #pragma omp critical 
    {  
    if(coop->winner == schedule_ID){ 
	    fout << "total duration: " << end - start << "\n";
	    fout << "total traverse: " << total_traverse << "\n";
	    fout << "max op traversed: " << maxOpTraversed << "\n";
    }
   }
    for( int i = 1; i <= FuncTimer::tickets.size(); i++ )
    {
        fout << i << " " << FuncTimer::tickets[( func_type ) i] << " " <<
             FuncTimer::times[( func_type ) i] << "\n";
    }

    fout.flush();

}


/*

		void
			testDriver( char *info, bool shrink, bool lowbound, bool level, bool twophase )
			{
				fout << "\nshrink: " << shrink << " termination: " << lowbound << " level: " << level << " two-phase: " << twophase << "\n";
				resetContext();
				printInfo( "\n" );
				printInfo( info );
				search_ag * sa = ( search_ag * ) malloc( sizeof( search_ag ) );
				sa->core = 1;
				sa->op = 1;
				sa->step = -1;
				sa->updateALAP = shrink;
				sa->preSearch = twophase;
				sa->levelbound = level;
				sa->lowbound = lowbound;
				printInfo( "pre-search...\n" );
				latex_global = globalLow = lowBound( 1, NULL );
				updateALAP( 1, NULL, shrink );

				fout << "\nglobal low: " << globalLow << "\n";

				double start = 0;
				double end = 0;

				if( twophase )
				{
					start = GetTickCount();
					currentSchedule_p[1].clear();
					branchBoundRCS_thread( sa );
					end = GetTickCount();
					fout << "pre-search total duration: " << end - start << "\n";

					latex_1p_c = total_traverse;
					latex_1p_t = end - start;
				}

				fout << "pre traverse: " << total_traverse << "\n";
				total_traverse = 0;
				sa->preSearch = false;
				printInfo( "formal-search...\n" );
				start = GetTickCount();
				currentSchedule_p[1].clear();
				branchBoundRCS_thread( sa );
				end = GetTickCount();

				printInfo( info );

				latex_optimal = optimalScheduleTime;
				fout << "The optimal schedule time is " << optimalScheduleTime <<
					"\n";


				for( int i = 1; i <= operations.size(); i++ )
				{
					Operation * op = operations[i];
					fout << op->id << "\t" << optimalSchedule_p[1][op] << "\n";
				}

				fout << "Finished branchbound? " << completeBranchBound << "\n";
				total_duration = end - start;
				fout << "total duration: " << end - start << "\n";
				fout << "total traverse: " << total_traverse << "\n";
				fout << "max op traversed: " << maxOpTraversed << "\n";

				for( int i = 1; i <= FuncTimer::tickets.size(); i++ )
				{
					fout << i << " " << FuncTimer::tickets[( func_type ) i] << " " <<
						FuncTimer::times[( func_type ) i] << "\n";
				}

				fout.flush();

			}
*/





		// main HLS algorithm +
		void
			branchBoundRCS_thread( void *arg )
			{
if(GetTickCount()-start>3600)
{
	cout<<"time out!!!"<<endl;
	exit(0);
}

				search_ag * sa = ( search_ag * ) arg;
				int i = sa->op;
				int core = sa->core;

				if( i == 1 && sa->preSearch )
				{
					printf( "init low: %d\n", globalLow );
				}

				if( i == 1 )
				{

					if( sa->lowbound && optimalScheduleTime <= globalLow )
					{	
						if(change){	
							end = GetTickCount();
						//	coop->set_winner (schedule_ID, globalLow);	

							printInfo( "lower bound == upper bound, terminate\n" );

#pragma omp critical 
							{
								cout << "-------------------------------------------\n";

	cout <<"Winner "<< coop->winner <<" The schedule "<< schedule_ID <<" time is " 
             << end -start << "  with optimal bound: "<<optimalScheduleTime << endl;

							}

							cout << "total duration: " << end - start << "\n";
							cout.flush();
							exit(0);}
					}
					else if( optimalScheduleTime < globalLow )
					{
						printInfo( "upper < low error!\n" );
						return;
					}

				/*	Operation * op = operations[1]->sortedOp;
						
					int index=0,dist=0;
                                        for(int k=1; k<=operations.size(); k++)
					{
					   op = operations[k];
					   if(ALAPofMultiThread[core][op] - ASAPofMultiThread[core][op]>dist)
				           {
						dist = ALAPofMultiThread[core][op] - ASAPofMultiThread[core][op];
						index = k;
					   }
					}
                                        
                                        op=operations[index];
					int start_step;
					int end_step;
					start_step = ASAPofMultiThread[core][op];
					end_step = ALAPofMultiThread[core][op];


					int step_size = ((end_step - start_step) / total_schedules +1);
				         ASAPofMultiThread[core][op] = start_step + schedule_ID * step_size ;	
					if( schedule_ID == total_schedules-1)
						ALAPofMultiThread[core][op]= end_step;
					else    ALAPofMultiThread[core][op]= start_step + (schedule_ID+1) * step_size-1;*/
				

				}

				if( sa->lowbound && optimalScheduleTime <= globalLow )
				{
					if(change){
						end = GetTickCount();
					//	coop->set_winner (schedule_ID, globalLow);	

						printInfo( "lower bound == upper bound, terminate\n" );
						cout << "total duration: " << end - start << "\n";

#pragma omp critical 
						{
							cout << "-------------------------------------------\n";

							cout <<"Winner "<< coop->winner <<" The schedule "<< schedule_ID <<" time is " 
             << end -start << "  with optimal bound: "<<optimalScheduleTime << endl;

						}
						cout.flush();
						exit(0);
					}
				}

				maxOpTraversed = max( maxOpTraversed, i );




int res_occupy=0;
				if( i <= operations.size() )

				{
					Operation * op = operations[i]->sortedOp;
			//	cout<<op->id<<endl;
	
					int start_step;
					int end_step;

					if( sa->step == -1 )

					{
						start_step = ASAPofMultiThread[core][op];
						end_step = ALAPofMultiThread[core][op];
					}
					else
					{
						start_step = sa->step;
						end_step = sa->step;
					}


					for( int step = start_step; step <= end_step; step++ )
					{

							currentSchedule_p[sa->core][op] = step;
						//	total_traverse++;
						if(op->id == endofLevel[op->level] &&
								( sa->levelbound  && levelBound( core, op, step ) ) )

						{
							needreturn = true;
							return_id = op->pre_id;
							return;
						}

						if( sa->lowbound && optimalScheduleTime <= globalLow )
						{
							if(change){
								end = GetTickCount();
								//		coop->set_winner (schedule_ID, globalLow);	

								printInfo( "lower bound == upper bound, terminate\n" );
								cout << "total duration: " << end - start << "\n";
#pragma omp critical 
								{
									cout << "-------------------------------------------\n";

									cout <<"Winner "<< coop->winner <<" The schedule "<< schedule_ID <<" time is " 
										<< end -start << "  with optimal bound: "<<optimalScheduleTime << endl;

								}
								cout.flush();
								exit(0);
							}	
						}

						int low = 0;
						map < Operation *, int >tempASAP;

						// save ASAP
						for( int i = 1; i <= operations.size(); i++ )
							tempASAP[operations[i]] =
								ASAPofMultiThread[core][operations[i]];

						// pass step as step into isPrecedence &
						// isResourceAvailable
						if( //	 isPrecedence( core, op, step ) &&
								isResourceAvailable( core, step, op->t, op->delay ) )
						{
		                                       

							currentSchedule_p[sa->core][op] = step;

							if( config_echo )
								printCurrentSchedule( sa->core, i );



							low = lowBound( core, operations[sa->op] );

							if( low < optimalScheduleTime /*time*/ )

							{
res_occupy++;
								occupyResource( core, step, op->t, op->delay );
								updateALAP( core, operations[sa->op], sa->updateALAP );

								updateASAP( core, op, step );

								search_ag * sa2 =
									( search_ag * ) malloc( sizeof( search_ag ) );
								sa2->op = i + 1;
								sa2->step = -1;
								sa2->core = core;
								sa2->updateALAP = sa->updateALAP;
								sa2->cpbound = sa->cpbound;
								sa2->preSearch = sa->preSearch;
								sa2->lowbound = sa->lowbound;
								sa2->levelbound = sa->levelbound;
								sa2->updateALAP = sa->updateALAP;

								//	if( ( op->id != endofLevel[op->level] && sa->preSearch ) || !sa->preSearch )
								{


									branchBoundRCS_thread( ( void * )( sa2 ) );
								}

								free( sa2 );

								releaseResource( core, step, op->t, op->delay );

								       if(needreturn  && return_id ==  op->id)
									 {
									//	if(  step == start_step )//&& op->id != operations[1]->sortedOp->id) 
									//	{	
									//		return_id = op->pre_id;
									//		return;
									//	}
										if(res_occupy==1&& op->pre_id == operations[i-1]->sortedOp->id){
											return_id = operations[i-1]->sortedOp->id; return;
										}
										else{
											return_id = -1;
											needreturn = false;
										}
									 }else
									 if(needreturn  && return_id !=  op->id)
									 {
										 return;
									 }
								 
							/*	if(needreturn)
								{
									if(step==start_step) return;
									else needreturn =false;
								}
*/

							}

							else
							{
								//	if( config_echo )
								//		fout << "omit from lowbound at op " << op->id
								//			<< " at level " << op->level << "\n";
								//	cout<<"Id: "<< schedule_ID<<" prune at " <<low
								//		 <<" because of omega "<<optimalScheduleTime<<" winnertime: "<<coop->winnerScheduleTime<<endl;
								continue;
							}
						}


						// restore ASAP
						for( int i = 1; i <= operations.size(); i++ )
							ASAPofMultiThread[core][operations[i]] =
								tempASAP[operations[i]];
					}
				}

				else
				{
					completeBranchBound = true;
					int scheduleTime = calculateMaxScheduleTime( core );
					char str[256];
					sprintf( str, "found a schedule: %d\n", scheduleTime );
					printInfo( str );
					lastFeasibleSchedule = currentSchedule_p[core];

					for( int i = 1; i <= operations.size(); i++ )
						printf( "%d", currentSchedule_p[core][operations[i]] );

					writeSchedule( core );
					fout.flush();
					if(optimalScheduleTime >= scheduleTime ) change =true;


					if( optimalScheduleTime > scheduleTime )
					{
					cout<<"schedule time is "<<scheduleTime<<endl;
						 
						completeBranchBound = true;
						optimalScheduleTime = scheduleTime;
						optimalSchedule_p[core] = currentSchedule_p[core];
						resource_snapshot_p[core] = resources_p[core];
					//	if(resource_history.size()>0) 
					//		{resource_history.clear();
					//		schedule_history.clear();
					//		}
                                         	resource_history.push_back(resources_p);
						schedule_history.push_back(optimalSchedule_p);

						resetALAP();//
					}

				/*	 int index1,time1;
						coop->get_winner(index1,time1);
						if(time1>=scheduleTime&&change)
						coop->set_winner(schedule_ID, scheduleTime);

							if(time1<optimalScheduleTime) 
						{

								if(time1>globalLow)
							optimalScheduleTime = time1-1;
								else {
								optimalScheduleTime = time1;
								}
								change =false;
								resetALAP();

						//	optimalScheduleTime = time1;
						//	resetALAP();
						}*/
				}
			}


		// main HLS algorithm +
		void
			basicEnu( int i )
			{

				if( basicfound )

					return;


				if( i <= operations.size() )

				{

					Operation * op = operations[i];


					int step = op->ASAP;



					// for( int step = op->ASAP; step <= op->ALAP; step++ )
					while( true )

					{

						// pass step as step into isPrecedence &
						// isResourceAvailable
						if( isPrecedence( op, step )
								&& isResourceAvailable( step, op->t, op->delay ) )

						{

							if( basicfound )

								return;


							currentSchedule[op] = basicSchedule[op] = step;

							occupyResource( step, op->t, op->delay );

							basicEnu( i + 1 );

							releaseResource( step, op->t, op->delay );

						}


						step++;

					}

				}

				else

				{

					printf( "basicEnu: found a schedule... %d\n",
							calculateMaxScheduleTime() );


					completeBranchBound = true;

					int scheduleTime = calculateMaxScheduleTime();



					if( scheduleTime <= basicSchedulingTime )

					{

						basicSchedulingTime = scheduleTime;

						fout << "initial basic schedule: " << scheduleTime << "\n";

						writeSchedule( "Found by Basic" );

					}

					optimalScheduleTime = w = min( w, basicSchedulingTime );

					basicfound = true;

					return;

				}
			}


		// evaluate all schedules and pick the max value +
		int
			calculateMaxScheduleTime()
			{

				int current_schedule_time = 0;

				int temp = 0;



				for( int i = 1; i <= operations.size(); i++ )

				{

					temp = currentSchedule[operations[i]] + operations[i]->delay - 1;

					current_schedule_time = max( current_schedule_time, temp );

				}

				return current_schedule_time;
			}


		int
			calculateMaxScheduleTime( int core )
			{

				int current_schedule_time = 0;

				int temp = 0;



				for( int i = 1; i <= operations.size(); i++ )

				{

					temp =
						currentSchedule_p[core][operations[i]] + operations[i]->delay - 1;

					current_schedule_time = max( current_schedule_time, temp );

				}

				return current_schedule_time;
			}


		// occupy resource of specified type
		void
			occupyResource( int step, type t, int delay )
			{

			//	FuncTimer::checkin( occupyResource_t );


				for( int i = step; i < step + delay; i++ )

				{

					// occupy the resource for subsequent steps
					resources[t][i]++;
	resources[(type)0][i] = resources[(type)0][i] + resourcePower[t];


				}

			//	FuncTimer::checkout( occupyResource_t );
			}

		void

			occupyResource( int core, int step, type t, int delay )
			{

			//	FuncTimer::checkin( occupyResource_t );


				for( int i = step; i < step + delay; i++ )

				{

					// occupy the resource for subsequent steps
					resources_p[core][t][i]++;
  resources_p[core][(type)0][i] = resources_p[core][(type)0][i] + resourcePower[t];

				}

			//	FuncTimer::checkout( occupyResource_t );
			}


		// release resource of specified type
		void
			releaseResource( int step, type t, int delay )
			{

			//	FuncTimer::checkin( releaseResource_t );


				for( int i = step; i < step + delay; i++ )

				{

					// release the resource for subsequent steps
					resources[t][i]--;
	resources[(type)0][i] = resources[(type)0][i] - resourcePower[t];

				}

			//	FuncTimer::checkout( releaseResource_t );
			}

		void

			releaseResource( int core, int step, type t, int delay )
			{

			//	FuncTimer::checkin( releaseResource_t );


				for( int i = step; i < step + delay; i++ )

				{

					// release the resource for subsequent steps
					resources_p[core][t][i]--;
 	resources_p[core][(type)0][i] = resources_p[core][(type)0][i] - resourcePower[t];

				}

			//	FuncTimer::checkout( releaseResource_t );
			}

		void

			updateASAP( Operation * op, int step )
			{

			//	FuncTimer::checkin( updateasap_t );


				for( set < Operation * >::const_iterator it =
						successorOperations[op].begin();
						it != successorOperations[op].end(); it++ )

				{


					if( ( *it )->ASAP < step + CPofNodes[op][( *it )] )

					{


						// printf( "updateASAP: updated op%d from %d to %d!\n", (
						// *it )->id, ( *it )->ASAP, step + CPofNodes[op][( *it )]
						// );
						// fout << "updateASAP: updated op" << ( *it )->id << "
						// from " << ( *it )->ASAP << "to " << step +
						// CPofNodes[op][( *it )] << "!\n";
						( *it )->ASAP = max( ( *it )->ASAP, step + CPofNodes[op][( *it )] );	// todo:
						// cp
						// between
						// opi
						// and
						// opj
					}

				}


			//	FuncTimer::checkout( updateasap_t );
			}


		void 	updateASAP( int core, Operation * op, int step )
			{

			//	FuncTimer::checkin( updateasap_t );


				for( set < Operation * >::const_iterator it =
						successorOperations[op].begin();
						it != successorOperations[op].end(); it++ )

				{


					if( ASAPofMultiThread[core][( *it )] <
							step + CPofNodes[op][( *it )] )

					{


						// printf( "updateASAP: updated op%d from %d to %d!\n", (
						// *it )->id, ( *it )->ASAP, step + CPofNodes[op][( *it )]
						// );
						// fout << "updateASAP: updated op" << ( *it )->id << "
						// from " << ( *it )->ASAP << "to " << step +
						// CPofNodes[op][( *it )] << "!\n";
						ASAPofMultiThread[core][( *it )] = max( ASAPofMultiThread[core][( *it )], step + CPofNodes[op][( *it )] );	// todo:
						// cp
						// between
						// opi
						// and
						// opj
					}

				}


			//	FuncTimer::checkout( updateasap_t );
			}


		void updateALAP( Operation * op )
			{

				// if( op->id == 27 )
				// int test = 0;

				if( op->id == operations.size() )

					return;


			//	FuncTimer::checkin( updateALAP_t );


				map < type, map < int, int > >resources_ = resources;

				map < Operation *, int >tempSchedule = currentSchedule;



				multiset < Operation > L_;

				map < int, int >L_array;

				map < int, int >S_;

				int w_ = 0;



				for( int i = 1; i <= op->id; i++ )

				{

					S_[i] = currentSchedule[operations[i]];

				}

				for( int i = op->id + 1; i <= operations.size(); i++ )

				{

					operations[i]->sort_id = CPofSubGraph[operations[i]];

					L_.insert( *operations[i] );

				}

				int count = 1;



				for( multiset < Operation >::iterator it = L_.begin();
						it != L_.end(); it++ )

				{

					L_array[count] = ( *it ).id;

					count++;

				}


				for( int k = 1; k <= operations.size() - op->id; k++ )

				{

					Operation * opk = operations[L_array[k]];


					// todo: opi or opk?
					// note: opk is input for single
					int j = 1;



					while( true )

					{

						if( isPrecedence( opk, j )
								&& isResourceAvailable( j, opk->t, opk->delay ) )

						{

							// only occupy, no release is needed
							occupyResource( j, opk->t, opk->delay );

							S_[opk->id] = j;

							currentSchedule[opk] = j;

							break;

						}


						j++;

					}


				}


				for( int l = 1; l <= operations.size() - op->id; l++ )

				{

					Operation * op = operations[L_array[l]];


					if( S_[op->id] == 0 )

						continue;


					w_ = max( S_[op->id] + op->delay, w_ );

				}


				if( w_ == 0 )

					return;


				// printf( "w_:w %d:%d!\n", w_, w );

				// todo: how to update w
				if( w_ < optimalScheduleTime )

				{

					printf( "updateALAP: updated from %d to %d!\n",
							optimalScheduleTime, w_ );

					fout << "updateALAP: updated from " << optimalScheduleTime <<
						" to " << w_ << "!\n";



					for( int k = 1; k <= operations.size(); k++ )

					{

						Operation * opk = operations[k];

						opk->ALAP = w_ - CPofPreRevGraph[opk] + 1;

					}

					writeSchedule( "Update by UpdateALAP" );


					w = optimalScheduleTime = w_;

					optimalSchedule = currentSchedule;

				}


				// restore resource usage pool
				resources = resources_;

				currentSchedule = tempSchedule;


			//	FuncTimer::checkout( updateALAP_t );
			}

		void

			updateALAP( int core, Operation * op, bool shrink )
			{

				// if( op->id == 27 )
				// int test = 0;
				int endid = ( op == NULL ) ? 0 : op->id;

				if( endid == operations.size() )

					return;




				map < type, map < int, int > >resources_ = resources_p[core];

				map < Operation *, int >tempSchedule = currentSchedule_p[core];



				multiset < Operation > L_;

				map < int, int >L_array;

				map < int, int >S_;

				int w_ = 0;



				for( int i = 1; i <= endid; i++ )
					S_[i] = currentSchedule_p[core][operations[i]->sortedOp];


				for( int i = endid + 1; i <= operations.size(); i++ )

				{

					//     operations[i]->sortedOp->sort_id = -operations[i]->sortedOp->ALAP ;
					operations[i]->sortedOp->sort_id = -operations[i]->sortedOp->ALAP;
					L_.insert( *operations[i]->sortedOp );

				}

				int count = 1;

				for( multiset < Operation >::iterator it = L_.begin();
						it != L_.end(); it++ )
				{
					L_array[count] = ( *it ).id;
					count++;
				}


				for( int k = 1; k <= operations.size() - endid; k++ )

				{

					Operation * opk = operations[L_array[k]];


					// todo: opi or opk?
					// note: opk is input for single
					int j = opk->ASAP;



					while( true )

					{

						if( isPrecedence( core, opk, j )
								&& isResourceAvailable( core, j, opk->t, opk->delay ) )

						{

							// only occupy, no release is needed
							occupyResource( core, j, opk->t, opk->delay );

							S_[opk->id] = j;

							currentSchedule_p[core][opk] = j;

							break;

						}


						j++;

					}


				}


				for( int l = 1; l <= operations.size(); l++ )

				{

					Operation * op = operations[l];


					//       if( S_[op->id] == 0 )

					//           continue;


					w_ = max( currentSchedule_p[core][op] + op->delay - 1, w_ );

				}


				if( w_ == 0 )

					return;

 			//	int index1,time1;
			//		coop->get_winner(index1,time1);
			//		if(time1>=w_)
			//		coop->set_winner(schedule_ID, w_);

				// printf( "w_:w %d:%d!\n", w_, w );

				// todo: how to update w
				if(w_<=optimalScheduleTime) change = true;

				if( w_ < optimalScheduleTime )

				{
                                        //change =true;         
					char str[256];


					sprintf( str, "updateALAP: upper bound updated from %d to %d at core %d at op %d!",
							optimalScheduleTime, w_, core, ( op == NULL ? 0 : op->sortedOp->id ) );

					if( config_echo )
						printInfo( str );


					if( shrink )
						for( int k = 1; k <= operations.size(); k++ )
						{
							Operation * opk = operations[k];
							ALAPofMultiThread[core][opk] = w_ - CPofPreRevGraph[opk] + 1;
							sprintf( str, "updateALAP: op %d update to %d at core %d at op %d!",
									k, ALAPofMultiThread[core][opk], core, ( op == NULL ? 0 : op->sortedOp->id ) );

							if( config_echo )
								printInfo( str );
						}

					w = optimalScheduleTime = w_;
					resetALAP();

					optimalSchedule_p[core] = currentSchedule_p[core];
					resource_snapshot_p[core] = resources_p[core];


//optimalSchedule_p[1] = listingSchedule;

//resource_snapshot_p[1] = resources;

	if(resource_history.size()>0) 
							{resource_history.clear();
							schedule_history.clear();
							}


                                         	resource_history.push_back(resource_snapshot_p);
						schedule_history.push_back(optimalSchedule_p);


					//   for(int i=1; i<=level_count; i++)
					//	   {
					//		history_level_info[i]->push_back(new vector<int> ());	
					//	
					// 	for(  set < int >::const_iterator set_it = level_l_h[i].begin(); set_it != level_l_h[i].end(); set_it++   )
					//	history_level_info[i]->back()->push_back(currentSchedule_p[core][operations[*set_it]] );
					//	
					//	   } 



					/*
					   for( int i = 1; i <= level_count; i++ )

					   {

					   map<int, int> maxLow;


					   for( set < int >::const_iterator it = level_l_h[i].begin();
					   it != level_l_h[i].end(); it++ )

					   {

					   maxLow[operations[*it]->graph] =
					   max( maxLow[operations[*it]->graph],
					   optimalSchedule_p[core][operations[*it]] +
					   CPofSubGraph[operations[*it]] );

					   }

					   for( set < int >::const_iterator it =
					   level_l_h[i].begin(); it != level_l_h[i].end();
					   it++ )

					   {

					   operations[*it]->ALAP =
					   min( operations[*it]->ALAP,
					   maxLow[operations[*it]->graph] - CPofPreRevGraph[operations[*it]] + 1 );

					   }
					   }

					 */


				}


				// restore resource usage pool
				resources_p[core] = resources_;

				currentSchedule_p[core] = tempSchedule;

				//	globalLow = max(globalLow, NULL);
			}


		//
		bool levelBound( Operation * op )
		{
cout<<"check level bound"<<endl;
			// if( op->id == 28 )
			// {
			// int test = 0;
			// }

		//	FuncTimer::checkin( levelbound_t );

			int l = *level_l_h[op->level].begin();

			int h = *level_l_h[op->level].rbegin();


			// getLhHh( &l, &h, op );

			bool temp_bool = true;


			if( op->id != h )

			{

			//	FuncTimer::checkout( levelbound_t );

				return false;

			}


			if( op->id == h )

			{//map < int, set < int > >level_l_h;
				//      for( int i = l; i <= h; i++ )

				for(  set < int >::const_iterator set_it = level_l_h[op->level].begin(); set_it != level_l_h[op->level].end(); set_it++   )
					temp_bool = temp_bool &
						( currentSchedule[operations[*set_it]] >= optimalSchedule[operations[*set_it]] );	// ||

				/*
				 * for( int i = l; i <= op->id - 1; i++ )
				 if( (
				 * currentSchedule[op] > currentSchedule[operations[i]] &&
				 * CPofSubGraph[op] > CPofSubGraph[operations[i]] && op->t ==
				 * operations[i]->t ) ||

				 ( currentSchedule[op] <
				 * currentSchedule[operations[i]] && CPofSubGraph[op] <
				 * CPofSubGraph[operations[i]] && op->t == operations[i]->t )
				 * )
				 {
				 FuncTimer::checkout( levelbound_t );
				 return true;
				 * }


				 */

			//	FuncTimer::checkout( levelbound_t );

				//   return temp_bool;

			}


			/*
			 *

			 for( int i = l; i <= op->id - 1; i++ )
			 if( (
			 * currentSchedule[op] > currentSchedule[operations[i]] &&
			 * CPofSubGraph[op] > CPofSubGraph[operations[i]] && op->t ==
			 * operations[i]->t ) ||

			 ( currentSchedule[op] <
			 * currentSchedule[operations[i]] && CPofSubGraph[op] <
			 * CPofSubGraph[operations[i]] && op->t == operations[i]->t ) )
			 * {
			 FuncTimer::checkout( levelbound_t );
			 return true;
			 }

			//(
			 * currentSchedule[op] + CPofSubGraph[op] >= optimalScheduleTime
			 * );

			 FuncTimer::checkout( levelbound_t );

			 return false;

			 * if( temp_bool )
			 return true;
			 else
			 return false;


			 */
			return false;
		}


		bool topoBound( Operation * op )
		{

			int l = *level_l_h[op->level].begin();

			int h = *level_l_h[op->level].rbegin();



			for( int i = l; i <= op->id - 1; i++ )

				if( ( currentSchedule[op] > currentSchedule[operations[i]]
							&& CPofSubGraph[op] > CPofSubGraph[operations[i]]
							&& op->t == operations[i]->t )
						||

						( currentSchedule[op] < currentSchedule[operations[i]]
						  && CPofSubGraph[op] < CPofSubGraph[operations[i]]
						  && op->t == operations[i]->t ) )

				{


					return true;

				}


			return false;
		}


		bool levelBound( int core, Operation * op, int step )
{


	//	if(resource_history.size()==0){
	//	resource_history.push_back(resource_snapshot_p);
	//	schedule_history.push_back(optimalSchedule_p);
	//	}
//	if( op->id != endofLevel[op->level] )
//	{
//		return false;
//	}	
//	else
	{

		for(int l=0; l< schedule_history.size(); l++)
		{	bool temp_bool = true;	
			bool temp_bool1 = true;
		//	bool temp_resource = true;
			bool  a_res = true;
			bool m_res = true;

			map < int, map < Operation *, int > >   tempSchedule = schedule_history[l];
			map < int, map < type, map < int, int > > > tempResource = resource_history[l];



			for( set<int>::const_iterator it = level_l_h[op->level].begin(); it != level_l_h[op->level].end(); it++ )
			{
				int current_time = currentSchedule_p[core][operations[*it]] ;
				int optimal_time = tempSchedule[core][operations[*it]] ;


				temp_bool = temp_bool &&
					( current_time >= optimal_time );
				temp_bool1 = temp_bool1 && ( current_time ==  optimal_time );


		/*		for(int k=0; k<7; k++)
					temp_resource = temp_resource   && (resources_p[core][(type)k][ current_time]
							<= tempResource[core][(type)k][optimal_time]) ;*/
/*
													  && (resources_p[core][multiplication][ current_time ]
													  >=resource_snapshot_p[core][multiplication][optimal_time ]);*/

			}

			temp_bool = temp_bool && !temp_bool1 ;
		//	return temp_bool;
			if(temp_bool) return true;

		}

	}

	//	if(temp_bool) printf("level bound gets effect \n");
	return false ;

}

		// calculate Lh and Hh
		void
			getLhHh( int *l, int *h, Operation * op )
			{

				int level = op->level;

				set < int >opWithSameLevel;



				for( map < int, Operation * >::const_iterator it =
						operations.begin(); it != operations.end(); it++ )

				{

					Operation * op = ( *it ).second;


					if( op->level == level )

						opWithSameLevel.insert( op->id );

					else

						continue;

				}


				*l = *opWithSameLevel.begin();

				*h = *opWithSameLevel.rbegin();
			}


		int
			upperBound( Operation * op )
			{

				int rs = 0;



				// similar to updateALAP except for using ALAP as the priority

				return rs;
			}


		// get low bound
		int
			lowBound( Operation * op )
			{

				map < type, map < int, int > >resources_ = resources;

				map < Operation *, int >tempSchedule = currentSchedule;



				// if( op->id == 28 )
				// int test = 0;

			//	FuncTimer::checkin( lowbound_t );

				int l = *level_l_h[op->level].begin();

				int h = *level_l_h[op->level].rbegin();


				int lowBoundTime = 0;

				int temp = 0;


				map < Operation *, int >start;



				// getLhHh( &l, &h, op );

				for( int k = l; k <= op->id; k++ )

				{

					Operation * op = operations[k];


					// if( lowBoundTime == 0 )
					// lowBoundTime = currentSchedule[op] + op->delay +
					// CPofSubGraph[op];
					// else
					lowBoundTime =
						max( lowBoundTime, currentSchedule[op] + CPofSubGraph[op] );

				}



				for( int k = op->id + 1; k <= h; k++ )

				{

					Operation * opk = operations[k];

					set < Operation * >setOfImmediatePrecedent =
						immediatePrecedentOperations[opk];


					for( set < Operation * >::const_iterator it =
							setOfImmediatePrecedent.begin();
							it != setOfImmediatePrecedent.end(); it++ )

					{

						Operation * op = ( *it );

						temp = currentSchedule[op] + op->delay;

						start[opk] = max( temp, start[opk] );

					}

				}


				// int r = 0;


				/*
				 *
				 for( int k = op->id + 1; k <= h; k++ )
				 {
				 Operation * opk =
				 * operations[k];
				 r = max( optimalSchedule[opk], start[opk] + 1
				 * );
				// r = start[opk] + 1;
				lowBoundTime = max( lowBoundTime, r
				 * + CPofSubGraph[opk] );
				 }


				 */

				for( int i = op->id + 1; i <= operations.size(); i++ )

				{

					int k = 0;



					for( int k = operations[i]->ASAP; k <= operations[i]->ALAP; k++ )

					{

						if( isPrecedence( operations[i], k ) )

						{

							// only occupy, no release is needed
							currentSchedule[operations[i]] = k;

							// occupyResource( k, operations[i]->t,
							// operations[i]->delay );
							break;

						}

					}


					k =
						max( currentSchedule[operations[i]], start[operations[i]] + 1 );

					lowBoundTime =
						max( lowBoundTime, k + CPofSubGraph[operations[i]] );

				}



				resources = resources_;

				currentSchedule = tempSchedule;


			//	FuncTimer::checkout( lowbound_t );

				// printf("low: %d\n", lowBoundTime);
				// if(lowBoundTime == optimalScheduleTime)
				// printf("*\n");
				return lowBoundTime;
			}





///////////////////////
	int
			lowBound_estimate( int core, Operation * op )
			{

				map < type, map < int, int > >resources_ = resources_p[core];

				map < Operation *, int >tempSchedule = currentSchedule_p[core];

				int endid = 0;

				if( op == NULL )
					endid = 0;
				else
					endid = op->id;



			//	FuncTimer::checkin( lowbound_t );





				int lowBoundTime = 0;

				int temp = 0;


				map < Operation *, int >start;



				multiset < Operation > L_;

				map < int, int >L_array;

				map < int, int >S_;

				int w_ = 0;




				for( int i = 1; i <= endid; i++ )
				{
					Operation * op = operations[i]->sortedOp;

					lowBoundTime =
						max( lowBoundTime,
								currentSchedule_p[core][op] + CPofSubGraph[op] - 1 );
				}

				/*
				   if(op!=NULL)
				   {
				   int l = *level_l_h[op->level].begin();

				   int h = *level_l_h[op->level].rbegin();

				   for( int k = endid + 1; k <= h; k++ )

				   {

				   Operation * opk = operations[k];

				   set < Operation * >setOfImmediatePrecedent =
				   immediatePrecedentOperations[opk];


				   for( set < Operation * >::const_iterator it =
				   setOfImmediatePrecedent.begin();
				   it != setOfImmediatePrecedent.end(); it++ )

				   {

				   Operation * op = ( *it );

				   temp = currentSchedule_p[core][op] + op->delay;

				   start[opk] = max( temp, start[opk] );

				   }

				   }

				   }
				 */


				int maxid = 0;


				for( int i = endid + 1; i <= operations.size(); i++ )

				{

					int opid = operations[i]->sortedOp->id;

					int k = ASAPofMultiThread[core][operations[opid]];
					//	int k = 1;

					while( true )
						//       for( int k = ASAPofMultiThread[core][operations[opid]];
						//               k <= operations[opid]->ALAP; k++ )

					{

						// only occupy, no release is needed
						if( isResourceAvailable( core, k,
									operations[opid]->t,
									operations[opid]->delay )
								//                    isPrecedence( core, operations[i], k )
						  )

						{

							currentSchedule_p[core][operations[opid]] = k;


							occupyResource( core, k, operations[opid]->t,
									operations[opid]->delay );
							break;

						}

						k++;

					}


					k =
						max( currentSchedule_p[core][operations[opid]],
								start[operations[opid]] + 1 );

					lowBoundTime =
						max( lowBoundTime, k + CPofSubGraph[operations[opid]] - 1 );


				}

				resources_p[core] = resources_;

				currentSchedule_p[core] = tempSchedule;



				return lowBoundTime;

			}

/////////////////////////////////////









		int
			lowBound( int core, Operation * op )
			{

				map < type, map < int, int > >resources_ = resources_p[core];

				map < Operation *, int >tempSchedule = currentSchedule_p[core];

				int endid = 0;

				if( op == NULL )
					endid = 0;
				else
					endid = op->id;



			//	FuncTimer::checkin( lowbound_t );





				int lowBoundTime = 0;

				int temp = 0;


				map < Operation *, int >start;



				multiset < Operation > L_;

				map < int, int >L_array;

				map < int, int >S_;

				int w_ = 0;




				for( int i = 1; i <= endid; i++ )
				{
					Operation * op = operations[i]->sortedOp;

					lowBoundTime =
						max( lowBoundTime,
								currentSchedule_p[core][op] + CPofSubGraph[op] - 1 );
				}

				/*
				   if(op!=NULL)
				   {
				   int l = *level_l_h[op->level].begin();

				   int h = *level_l_h[op->level].rbegin();

				   for( int k = endid + 1; k <= h; k++ )

				   {

				   Operation * opk = operations[k];

				   set < Operation * >setOfImmediatePrecedent =
				   immediatePrecedentOperations[opk];


				   for( set < Operation * >::const_iterator it =
				   setOfImmediatePrecedent.begin();
				   it != setOfImmediatePrecedent.end(); it++ )

				   {

				   Operation * op = ( *it );

				   temp = currentSchedule_p[core][op] + op->delay;

				   start[opk] = max( temp, start[opk] );

				   }

				   }

				   }
				 */


				int maxid = 0;


				for( int i = endid + 1; i <= operations.size(); i++ )

				{

					int opid = operations[i]->sortedOp->id;

					int k = ASAPofMultiThread[core][operations[opid]];
					//	int k = 1;

					while( true )
						//       for( int k = ASAPofMultiThread[core][operations[opid]];
						//               k <= operations[opid]->ALAP; k++ )

					{

						// only occupy, no release is needed
						if( isResourceAvailable( core, k,
									operations[opid]->t,
									operations[opid]->delay )
								//                    isPrecedence( core, operations[i], k )
						  )

						{

							currentSchedule_p[core][operations[opid]] = k;


							occupyResource( core, k, operations[opid]->t,
									operations[opid]->delay );
							break;

						}

						k++;

					}


					k =
						max( currentSchedule_p[core][operations[opid]],
								start[operations[opid]] + 1 );

					lowBoundTime =
						max( lowBoundTime, k + CPofSubGraph[operations[opid]] - 1 );


				}

				resources_p[core] = resources_;

				currentSchedule_p[core] = tempSchedule;



				return lowBoundTime;

			}


		// get all immediate precedent operations
		set < Operation * >getImmediatePrecedent( Operation * op )
		{

			set < Operation * >rs;


			for( set < Dependency * >::const_iterator it =
					dependencies.begin(); it !=  dependencies.end(); it++ )

			{

				if( ( *it )->sink == op )

				{

					Operation * op = ( *it )->source;

					rs.insert( op );

				}

			}


			return rs;
		}


		// determine whether resource of specified type is available
		bool isResourceAvailable( int step, type t, int delay )
		{

		//	FuncTimer::checkin( isResourceAvailable_t );


			//    if( resources[t].size() == 0 )

			//        resources[t].clear();


			for( int i = step; i < step + delay; i++ )

			{

				// occupy the for subsequent steps
				if( resources[t][i] >= resourcePool[t] || (resources[(type)0][i] +resourcePower[t]) > resourcePool[(type)0]  )

				{

				//	FuncTimer::checkout( isResourceAvailable_t );
					if(resourcePower[t]> resourcePool[(type)0])
					{
						cout<<"a single operation's power is larger than the specified power!"<<endl;
						exit(0);		
					}
					return false;

				}

			}


		//	FuncTimer::checkout( isResourceAvailable_t );

			return true;
		}

		bool isResourceEqual( int core, int step, type t, int delay )
		{

		//	FuncTimer::checkin( isResourceAvailable_t );


			//    if( resources_p[core][t].size() == 0 )

			//        resources_p[core][t].clear();


			for( int i = step; i < step + delay; i++ )

			{

				// occupy the for subsequent steps
				if( resources_p[core][t][i] + 1 != resourcePool[t] )

				{

				//	FuncTimer::checkout( isResourceAvailable_t );

					return false;

				}

			}


		//	FuncTimer::checkout( isResourceAvailable_t );

			return true;
		}

		bool isResourceAvailable( int core, int step, type t, int delay )
		{

		//	FuncTimer::checkin( isResourceAvailable_t );


			//    if( resources_p[core][t].size() == 0 )

			//        resources_p[core][t].clear();


			for( int i = step; i < step + delay; i++ )

			{

				// occupy the for subsequent steps
				if( resources_p[core][t][i] >= resourcePool[t] || (resources_p[core][(type)0][i]+resourcePower[t]) > resourcePool[(type)0]  )

				{

				//	FuncTimer::checkout( isResourceAvailable_t );
	if(resourcePower[t]> resourcePool[(type)0])
					{
						cout<<"a single operation's power is larger than the specified power!"<<endl;
						exit(0);		
					}

					return false;

				}

			}


		//	FuncTimer::checkout( isResourceAvailable_t );

			return true;
		}


		bool isPrecedence( Operation * op, int step, map < int, int >schedule )
		{

		//	FuncTimer::checkin( isPrecedence_t );

			bool rs = true;


			set < Operation * >setOfImmediatePrecedent =
				immediatePrecedentOperations[op];


			for( set < Operation * >::const_iterator it =
					setOfImmediatePrecedent.begin();
					it != setOfImmediatePrecedent.end(); it++ )

			{

				Operation * op = ( *it );

				rs = rs & ( schedule[op->id] + op->delay <= step );


				if( rs == false )

				{

				//	FuncTimer::checkout( isPrecedence_t );

					return rs;

				}

			}


			/*
			 *
			 for( set<Dependency*>::const_iterator it =
			 * dependencies.begin(); it != dependencies.end(); it++ )
			 {
			 if(
			 * ( *it )->sink == op )
			 {
			 Operation * op = ( *it )->source;
			 rs
			 * = rs & ( currentSchedule[op] + op->delay <= step );

			 if( rs
			 * == false )
			 return rs;
			 }
			 }

			 */
		//	FuncTimer::checkout( isPrecedence_t );

			return rs;
		}


		// determine whether the precedent operations has finished
		bool isPrecedence( Operation * op, int step )
		{

		//	FuncTimer::checkin( isPrecedence_t );

			bool rs = true;


			set < Operation * >setOfImmediatePrecedent =
				immediatePrecedentOperations[op];


			for( set < Operation * >::const_iterator it =
					setOfImmediatePrecedent.begin();
					it != setOfImmediatePrecedent.end(); it++ )

			{

				Operation * op = ( *it );

				rs = rs & ( currentSchedule[op] + op->delay - 1 < step );


				if( !rs )

				{

				//	FuncTimer::checkout( isPrecedence_t );

					return rs;

				}

			}


			/*
			 *
			 for( set<Dependency*>::const_iterator it =
			 * dependencies.begin(); it != dependencies.end(); it++ )
			 {
			 if(
			 * ( *it )->sink == op )
			 {
			 Operation * op = ( *it )->source;
			 rs
			 * = rs & ( currentSchedule[op] + op->delay <= step );

			 if( rs
			 * == false )
			 return rs;
			 }
			 }

			 */
		//	FuncTimer::checkout( isPrecedence_t );

			return rs;
		}


		bool isPrecedence( int core, Operation * op, int step )
		{

		//	FuncTimer::checkin( isPrecedence_t );

			bool rs = true;


			set < Operation * >setOfImmediatePrecedent =
				immediatePrecedentOperations[op];


			for( set < Operation * >::const_iterator it =
					setOfImmediatePrecedent.begin();
					it != setOfImmediatePrecedent.end(); it++ )

			{

				Operation * op = ( *it );

				//     if( currentSchedule_p[core][op] == 0 )
				//        return false;

				rs = rs & ( currentSchedule_p[core][op] + op->delay - 1 < step );


				if( rs == false )

				{

				//	FuncTimer::checkout( isPrecedence_t );

					return rs;

				}

			}


		//	FuncTimer::checkout( isPrecedence_t );

			return rs;
		}


		set < Operation * >getSuccessor( Operation * op )
		{

			set < Operation * >rs;


			Graph * subGraph = getSubGraph( op );


			for( set < Operation * >::const_iterator it =
					subGraph->operations.begin();
					it != subGraph->operations.end(); it++ )

			{

				rs.insert( ( *it ) );

			}


			rs.erase( op );


			return rs;
		}




		// initialize best schedule and best schedule time
		void
			initOptimalSchedule()
			{

				for( map < int, Operation * >::const_iterator it =
						operations.begin(); it != operations.end(); it++ )

				{

					Operation * op = ( *it ).second;

					optimalSchedule[op] = op->id;

				}

				optimalScheduleTime = w = 20;
			}


		// give a feasible list schedule and w
		void
			listSchedule()
			{

				map < type, map < int, int > >resources_ = resources;


				multiset < Operation > L_;

				map < int, int >L_array;

				int w_ = 0;



				for( int i = 1; i <= operations.size(); i++ )

				{

					// printf( "listSchedule: processing op %d...\n", i );
					operations[i]->sort_id = CPofSubGraph[operations[i]];
					//operations[i]->sort_id = -operations[i]->id;
					L_.insert( *operations[i] );

				}

				int count = 1;



				for( multiset < Operation >::iterator it = L_.begin();
						it != L_.end(); it++ )

				{

					L_array[count] = ( *it ).id;

					count++;

				}

				//    for( int l = operations[L_array[1]]->ASAP; l <= operations[L_array[1]]->ASAP + 10; l++ )
				//    {
				//        resources = resources_;

				for( int k = 1; k <= operations.size(); k++ )

				{

					Operation * opk = operations[L_array[k]];
					int j =  opk->ASAP;

					while( true )
					{
						if( isPrecedence( opk, j )
								&& isResourceAvailable( j, opk->t, opk->delay ) )
						{

							// only occupy, no release is needed
							occupyResource( j, opk->t, opk->delay );
							listingSchedule[opk] = currentSchedule[opk] = j;
							break;
						}

						j++;
					}
				}

				for( int m = 1; m <= operations.size(); m++ )

				{

					Operation * op = operations[L_array[m]];

					w_ = max( listingSchedule[op] + op->delay - 1, w_ );

				}

				listSchedulingTime = w_;
				optimalScheduleTime = w = min( w, w_ );
			//	coop->set_winner(0,optimalScheduleTime);

				//        l++;
				//    }

optimalSchedule_p[1] = listingSchedule;

resource_snapshot_p[1] = resources;

	if(resource_history.size()>0) 
							{resource_history.clear();
							schedule_history.clear();
							}


                                         	resource_history.push_back(resource_snapshot_p);
						schedule_history.push_back(optimalSchedule_p);



				// restore resource usage pool
				resources = resources_;
			}
	
		void resetALAP()
		{
			w = optimalScheduleTime;
			initALAP();


		//	for( map < int, Operation * >::const_iterator it =
		//			operations.begin(); it != operations.end(); it++ )
		//		ASAPofMultiThread[1][( *it ).second] = ( *it ).second->ASAP;

			for( map < int, Operation * >::const_iterator it =
					operations.begin(); it != operations.end(); it++ )
				ALAPofMultiThread[1][( *it ).second] = ( *it ).second->ALAP;


		}

		void resetContext()
		{
			resources.clear();
			completeBranchBound = false;
			total_traverse = 0;
			maxOpTraversed = 0;
		//	optimalScheduleTime = w = listSchedulingTime;
			currentSchedule = optimalSchedule = listingSchedule;
			FuncTimer::init();
		//	currentSchedule_p[1] = optimalSchedule;
		//	optimalSchedule_p[1] = optimalSchedule;
		//	resources_p.clear();
		//	resource_snapshot_p.clear();

			for( map < int, Operation * >::const_iterator it =
					operations.begin(); it != operations.end(); it++ )
				ASAPofMultiThread[1][( *it ).second] = ( *it ).second->ASAP;

			for( map < int, Operation * >::const_iterator it =
					operations.begin(); it != operations.end(); it++ )
				ALAPofMultiThread[1][( *it ).second] = ( *it ).second->ALAP;

		}

		void
			printResult( fstream * fout )
			{

				*fout << "The optimal schedule time is " << optimalScheduleTime <<
					"\n";


				for( map < Operation *, int >::const_iterator it =
						optimalSchedule.begin(); it != optimalSchedule.end(); it++ )

				{

					Operation * op = ( *it ).first;

					int step = ( *it ).second;


					*fout << op->id << "\t" << optimalSchedule[op] << "\n";		

				}

				*fout << "Finished branchbound? " << completeBranchBound << "\n";
			}

	/*	void parallelTestDriver( void * arg )
		{
			resetContext();
			parallel_ag * pa = ( parallel_ag* )arg;
			int coreNumber = pa->core_limit;
			char info[256];
			sprintf( info, "using %d core(s) to perform...\n", coreNumber );
			printInfo( info );

			//pa->assignmentSemaphore = CreateSemaphore( NULL, 1, 1, NULL );
			//sem_init( &pa->assignmentSemaphore, 1, 1 );



			for( int i = 1; i <= assignment; i++ )
				pa->assignmentMap.insert( i );

			for( int i = 1; i <= coreNumber; i++ )
			{
				currentSchedule_p[i] = basicSchedule;
				optimalSchedule_p[i] = basicSchedule;
				resources_p[i].clear();
				resource_snapshot_p[i].clear();

				for( map < int, Operation * >::const_iterator it =
						operations.begin(); it != operations.end(); it++ )

					ASAPofMultiThread[i][( *it ).second] = ( *it ).second->ASAP;


			}

			long branch_with_parallel_start = GetTickCount();

			long branch_with_parallel_end = 0;

			long branch_with_parallel_duration = 0;

			int count = 0;




			while( branch_with_parallel_duration < 10 )

			{

				for( int i = 1; i <= coreNumber; i++ )

				{

					thread_ag * ta = ( thread_ag * ) malloc( sizeof( thread_ag ) );

					if( coreNumber >= assignment )
					{
						ta->lower = i;
						ta->upper = i;
					}
					else
					{
						ta->lower =
							( i - 1 ) * assignment / ( unsigned int )( coreNumber ) * 1.0 +
							1;

						ta->upper =
							( i +
							  1 ) * ( assignment / ( unsigned int )( coreNumber ) ) * 1.0 >
							assignment ? assignment : ( i ) * assignment /
							( unsigned int )( coreNumber ) * 1.0;
					}

					ta->coreID = i;
					ta->assignmentMap = &pa->assignmentMap;
					ta->assignmentSemaphore = &pa->assignmentSemaphore;

					// threadMap[i] = ( int )_beginthread( coreScheduler, 0, ( void* )ta );//


					// SetThreadPriority( threadMap[i],
					// THREAD_PRIORITY_HIGHEST );
					// SetThreadAffinityMask( threadMap[i], ( DWORD_PTR
					// )coreNumber );
					// WaitForSingleObject( threadMap[i], INFINITE );
				}

				for( int i = 1; i <= coreNumber; i++ )
					;//WaitForSingleObject( threadMap[i], INFINITE );

				//pthread_join( threadMap[i], NULL );


				branch_with_parallel_end = GetTickCount();

				branch_with_parallel_duration =
					branch_with_parallel_end - branch_with_parallel_start;

				count++;

			}





		
			fout.flush();

			fout << "parallel total duration: " << ( branch_with_parallel_duration )
				* 1.0 / count << "with core " << coreNumber << "\n";

}*/

};




//int core_limit = 16;
//int environment_core_limit = 96;


//HANDLE semephore;
//int assignment = 0;
//int count = 0;
//map < int, int > threadMap;



// variables for parallel algorithm
// need initializtion



		void cooperation::get_winner (int & i, int & t)
		{

		//	 #pragma omp critical 
			{
	                    i = winner;
			    t= winnerScheduleTime;
			}
		}

		void cooperation::set_winner(int i, int t)
		{
			  
                          omp_set_lock(&lock);
		        {
				if(t<winnerScheduleTime){
				winner = i;
				winnerScheduleTime =t;}

			}
			omp_unset_lock(&lock);
		}

		

		cooperation::cooperation(int n)
		{
			omp_init_lock(&lock);

			int winner=-1;
			winnerScheduleTime = INT_MAX;
			scheduleNum=n;
			schedules = NULL;// new schedule[n];
		}

		cooperation::~cooperation()
		{
		        if(schedules!=NULL)
			delete [] schedules;
				omp_destroy_lock(&lock);

		}

	void cooperation::setScheduleNum(int n){
		
		scheduleNum=n;
		if(schedules==NULL)
		schedules = new scheduler [n];
		for(int i=0; i<n;i++)
		{
			schedules[i].schedule_ID=i;
			schedules[i].total_schedules = n;
			schedules[i].set_cooperation(this);
		}
	}


int graph_count = 0;


// variables for parallel algorithm


cooperation  coop(4);

int main( int argc, char **argv )
{
    bool config_multithread;
    int config_add;
    int config_multi;
    bool config_multiround;
    const char ConfigFile[] = "config.txt";
    Config configSettings( ConfigFile );

    config_multithread = configSettings.Read( "multithread", false );
    config_add = configSettings.Read( "add", 0 );
    config_multi = configSettings.Read( "multi", 0 );
    config_multiround = configSettings.Read( "multiround", false );
    config_echo = configSettings.Read( "echo", false );
    config_low = configSettings.Read( "low", false );
    config_level = configSettings.Read( "level", false );
    int config_coreNum =  1;

    int config_power = configSettings.Read("power", 999999);

 
cout<<"try the power with " <<config_power<<endl;


    FuncTimer::init();
    ifstream fin2( "target.txt" );

    string filename;

    fstream latexout;

    latexout.open( "latex.txt", ios::out );

   coop.setScheduleNum(config_coreNum);




    while( getline( fin2, filename ) )
    {
	    ifstream fin3( "resource.txt", ios::in );

	    while( !fin3.eof() )
	    {
		    int add_number = 0, multi_number = 0, div_number=0, mem_number =0, shift_number=0, other_number=0;
		    fin3 >> add_number >> multi_number >>div_number>>mem_number>>shift_number>>other_number;
		    if(add_number ==0 && multi_number ==0 && div_number ==0&& mem_number ==0&&shift_number ==0 && other_number==0) break;

		    char str[256];
		    sprintf( str, "process file %s with %d adders and %d multipliers\n", filename.c_str(), add_number, multi_number );
		    printInfo( str );

		    char rsFileName[256];
		    sprintf( rsFileName, "%s_rs_%d%d.txt", filename.c_str(), add_number, multi_number );

		    fout.open( rsFileName, ios::out );


		    // fstream fin( argv[1], ios::in );
		    // fstream fin( "AR_r.txt", ios::in );
		    fstream fin( filename.c_str(), ios::in );

		    // fout.open( argv[2], ios::out );
		    int operation_count,
			constraint_count, add_count, multi_count, div_count, 
			mem_count, shift_count, other_count, add_delay=1, multi_delay=2, div_delay=2, mem_delay=1, shift_delay=1, other_delay =1,
			level, graph;

		    fin >> operation_count >> constraint_count ;

		    	
                   //  >> add_count >> multi_count
		//	    >> add_delay >> multi_delay;

		    fout << "total operations: " << operation_count << "\n";

		    fout << "total constraints: " << constraint_count << "\n";

		    add_count = add_number;
		    multi_count = multi_number;
		    div_count = div_number;
	            mem_count = mem_number;
		    shift_count =shift_number;
			other_count =other_number;


		    fout << "total adder: " << add_count << "\n";

		    fout << "total muliplier: " << multi_count << "\n";

		    for(int j=0; j< config_coreNum; j++){
			    // coop.schedules[j].addOperation(id,type,level, graph, add_delay, multi_delay);
  coop.schedules[j].resourcePool[( enum type ) 0] = config_power;

			    coop.schedules[j].resourcePool[( enum type ) 1] = add_count;
			    coop.schedules[j].resourcePool[( enum type ) 2] = multi_count;
			    coop.schedules[j].resourcePool[( enum type ) 3] = div_count;
 			    coop.schedules[j].resourcePool[( enum type ) 4] = mem_count;
			    coop.schedules[j].resourcePool[( enum type ) 5] = shift_count;
	coop.schedules[j].resourcePool[( enum type ) 6] = other_count;
	for(int k=7; k<30; k++)
				 coop.schedules[j].resourcePool[( enum type ) k] = 1;


 coop.schedules[j].resourcePower[( enum type ) 0 ] = 0;
			    coop.schedules[j].resourcePower[( enum type ) 1] = 10;
			    coop.schedules[j].resourcePower[( enum type ) 2] = 20;
			    coop.schedules[j].resourcePower[( enum type ) 3] = 20;
 			    coop.schedules[j].resourcePower[( enum type ) 4] = 15;
			    coop.schedules[j].resourcePower[( enum type ) 5] = 10;
 			coop.schedules[j].resourcePower[( enum type ) 6] = 10;
	for(int k=7; k<30; k++)
					 coop.schedules[j].resourcePower[( enum type ) k] = 0;
	
		    }

		    printf( "Reading from test case file...\n" );


		    for( int i = 0; i < operation_count; i++ )
		    {
			    int id, type;
			    fin >> id >> type >> level >> graph;
			    fout << id << " " << type << "\n";
			    for(int j=0; j< config_coreNum; j++){
			//	    coop.schedules[j].addOperation(id,type,level, graph, add_delay, multi_delay);

 coop.schedules[j].addOperation(id,type,level, graph, add_delay, multi_delay, div_delay, mem_delay, shift_delay, other_delay );







			    }
		    }



		    for( int i = 0; i < constraint_count; i++ )
		    {
			    int id, source, sink;
			    fin >> source >> sink;
			    fout << i << " " << source << " " << sink << "\n";
                           for(int j=0; j<config_coreNum; j++){
				coop.schedules[j].addDependences(i,source,sink);
			   }
		    }
		    // invoke the algorithm
	
		    for(int coreNum=0; coreNum<config_coreNum; coreNum++)
		    {
			    coop.schedules[coreNum].topoSort();
			    coop.schedules[coreNum].initDFG();
			    coop.schedules[coreNum].preEnumaration();
		    }


		    


int lowb=coop.schedules[0].lowBound_estimate(1,NULL); 
int upb =coop.schedules[0].optimalScheduleTime;

if(upb-lowb<config_coreNum)
config_coreNum = upb-lowb+1;

int omega_interval = (upb+1-lowb)/ (config_coreNum);



if(omega_interval ==0) omega_interval =1;


coop.winner = 0; 
coop.winnerScheduleTime = upb;

cout<<"hello mingsong : "<<lowb<<" "<<upb<<" "<<omega_interval<<"  "<<coop.schedules[0].listSchedulingTime<<endl;




  omp_set_num_threads(config_coreNum);

  for(int coreNum=0; coreNum<config_coreNum; coreNum++)
  {

	  if(  coreNum != (config_coreNum-1) )
	  {
		int bb= lowb + omega_interval * (coreNum+1);
		if( bb > upb ) bb= upb;
		 coop.schedules[coreNum].optimalScheduleTime = coop.schedules[coreNum].listSchedulingTime =  coop.schedules[coreNum].w =bb;	  }
	  else 
	  { coop.schedules[coreNum].optimalScheduleTime = coop.schedules[coreNum].listSchedulingTime =  coop.schedules[coreNum].w = upb ;
	  }
	  cout<<"the current schedule has a upper bound " << coop.schedules[coreNum].optimalScheduleTime <<endl;

	coop.schedules[coreNum].resetALAP();


  }



		#pragma omp parallel for   schedule(dynamic) 
                    for(int coreNum=0; coreNum<config_coreNum; coreNum++)
		    {

		       coop.schedules[coreNum].testDriver( "composite", true, true, true, false );
		        if(coop.schedules[coreNum].change || (coop.schedules[coreNum].optimalScheduleTime+1 == coop.winnerScheduleTime 
										 )  )
		       {
			       cout<<"the winner is coreNum "<<coreNum<<endl;
			       printf( "Finished...\n" );

			       fout << "-------------------------------------------\n";
#pragma omp critical 
			       {
				       cout << "-------------------------------------------\n";

				     
	cout <<"Winner "<< coop.winner <<" The schedule "<< coreNum <<" time is " 
             << coop.schedules[coreNum].end -coop.schedules[coreNum].start  
        	<< "  with optimal bound: "<< coop.winnerScheduleTime << endl;
			       }


			       fout.flush();

			       fout.close();
			       latexout.flush();
			       latexout.close();
			       fin2.close();
cout.flush();
			       exit(0);
		       }
		    }
                //    cout<<"the winner is core "<<coop.winner<<endl;
                    
		    fout.flush();


		  
		    printf( "Finished...\n" );

		    fout << "-------------------------------------------\n";


		    fout.flush();

		    fout.close();

		    }
	    }

 #pragma omp critical 
    {
  cout << "-------------------------------------------\n";

	cout <<"Winner "<< coop.winner <<" The schedule "<< -1 <<" time is " 
             << coop.schedules[config_coreNum-1].end -coop.schedules[config_coreNum-1].start  
        	<< "  with optimal bound: "<<coop.schedules[config_coreNum-1].optimalScheduleTime << endl;
    }



	    latexout.flush();
	    latexout.close();
	    fin2.close();
		cout.flush();
	    return 0;
    }



